"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRemote = void 0;
var tslib_1 = require("tslib");
var vue_1 = require("vue");
var vue_router_1 = require("vue-router");
var inMemoryInitialState = undefined;
function saveInitialState(state) {
    inMemoryInitialState = state;
}
var createRemote = function (App, config) {
    return function (options) {
        if (options === void 0) { options = {
            isSelfHosted: false,
        }; }
        var isSelfHosted = options.isSelfHosted, initialState = options.initialState;
        var _a = config || {}, createRuntime = _a.createRuntime, onBeforeMount = _a.onBeforeMount;
        var log = createRuntime === null || createRuntime === void 0 ? void 0 : createRuntime.log;
        if (inMemoryInitialState === undefined)
            saveInitialState(initialState);
        function mount(el, _a) {
            var _this = this;
            var _b = _a === void 0 ? {} : _a, _c = _b.runtime, runtime = _c === void 0 ? createRuntime === null || createRuntime === void 0 ? void 0 : createRuntime() : _c, onRemoteNavigate = _b.onRemoteNavigate, basename = _b.basename, pathname = _b.pathname;
            var cleanups = [];
            var onBeforeUnmountCallbacks = [];
            var onUnmountedCallbacks = [];
            var router = undefined;
            var history = isSelfHosted
                ? (0, vue_router_1.createWebHistory)(basename)
                : (0, vue_router_1.createMemoryHistory)(basename);
            if (el) {
                var runMount = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                    var initialPath, appProps, routes, app_1, error_1;
                    var _a;
                    return tslib_1.__generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _b.trys.push([0, 2, , 3]);
                                initialPath = [basename, pathname]
                                    .join("/")
                                    .replace(/\/{2,}/g, "/");
                                appProps = onBeforeMount === null || onBeforeMount === void 0 ? void 0 : onBeforeMount({
                                    runtime: runtime,
                                    isSelfHosted: isSelfHosted,
                                    initialState: inMemoryInitialState,
                                    saveInitialState: saveInitialState,
                                    onBeforeUnmount: function (callback) {
                                        onBeforeUnmountCallbacks.push(callback);
                                    },
                                    onUnmounted: function (callback) {
                                        onUnmountedCallbacks.push(callback);
                                    },
                                });
                                routes = [];
                                if (basename && basename !== "/") {
                                    routes.push({ path: "/", component: { template: "" } });
                                    routes.push({ path: basename, component: App });
                                }
                                else {
                                    routes.push({ path: "/", component: App });
                                }
                                router = (0, vue_router_1.createRouter)({
                                    history: history,
                                    routes: routes,
                                });
                                return [4 /*yield*/, router.replace(initialPath)];
                            case 1:
                                _b.sent();
                                app_1 = (0, vue_1.createApp)(App, tslib_1.__assign(tslib_1.__assign({}, appProps), { isSelfHosted: isSelfHosted }))
                                    .provide("runtime", runtime)
                                    .use(router);
                                app_1.mount(el);
                                cleanups = cleanups.concat(onBeforeUnmountCallbacks);
                                cleanups.push(function () { return app_1.unmount(); });
                                cleanups = cleanups.concat(onUnmountedCallbacks);
                                if (onRemoteNavigate) {
                                    cleanups.push(router.beforeEach(function (to, from) {
                                        if (from !== vue_router_1.START_LOCATION) {
                                            onRemoteNavigate === null || onRemoteNavigate === void 0 ? void 0 : onRemoteNavigate(to.path, {
                                                hash: to.hash,
                                                // TODO search: to.query,
                                            });
                                        }
                                    }));
                                }
                                return [3 /*break*/, 3];
                            case 2:
                                error_1 = _b.sent();
                                log === null || log === void 0 ? void 0 : log(error_1);
                                el.innerText = "Error: ".concat((_a = error_1.message) !== null && _a !== void 0 ? _a : error_1);
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); };
                runMount();
            }
            return {
                unmount: function () {
                    cleanups.forEach(function (cleanup) { return cleanup(); });
                },
                onHostNavigate: function (newPathname) {
                    var pathname = history.location;
                    if (newPathname !== pathname)
                        router === null || router === void 0 ? void 0 : router.push(newPathname);
                },
            };
        }
        return { mount: mount, createRuntime: createRuntime };
    };
};
exports.createRemote = createRemote;
